<template>
  <div :class="'badge-container badge-state-' + state">
    <Icon v-if="showIcon" :icon="icon" class="badge-icon" />
    <span v-if="label" class="badge-label">
      {{ label }}
    </span>
  </div>
</template>

<script lang="ts">
import { Vue, Options, prop } from 'vue-class-component';
import Icon from '@/components/UIElements/Icon.vue'
import { BadgeStates } from '@/enums'

class Props {
  showIcon?: boolean = prop({
    required: false,
  });
  label?: string = prop({
    required: false,
  });
  state: string = prop({
    required: true,
  });
}

@Options({
  components: {
    Icon,
  },
})
export default class Badge extends Vue.with(Props) {
  BadgeStates:typeof BadgeStates = BadgeStates

  get icon ():string {
    switch (this.state) {
      case BadgeStates.Danger :
        return 'cancel-circle';
      case BadgeStates.Info :
        return 'cross';
      case BadgeStates.Success :
        return 'check-circle';
      case BadgeStates.Warning :
        return 'add';
      default :
        return '';
    }
  }
}
</script>

<style lang="scss" scoped>
@import '@/css/variables'; 

.badge-container {
  height: 24px;
  border-radius: 4px;
  width: fit-content;
  color: $color-neutral-grey-60;
  display: flex;
  padding-left:4px;
  .badge-label {
    padding: 2px 8px 2px 4px;
    font-weight: 500;
    font-size: 12px;
    line-height: 20px;
  }
  .badge-icon {
    margin-left: 4px;
  }
  &.badge-state-danger {
    background-color: $color-orange;
  }
  &.badge-state-info {
    background-color: $color-blue;
  }
  &.badge-state-neutral {
    background-color: $color-neutral-grey-8;
  }
  &.badge-state-success {
    background-color: $color-green;
  }
  &.badge-state-warning {
    background-color: $color-yellow;
  }
}
</style>
<style lang="scss">
@import '@/css/variables'; 
.badge-container {
  .icon {
    background: $color-neutral-grey-60 !important;
    transform: scale(0.8);
  }
}
</style>